--函数名称：cal_rate
--功能：
--			计算停车收费费率
--参数说明

--class：收费类别
--				1：	1类街道
--				2：	2类街道
--				3：	3类街道
--				4：	医大二院
--				5：	按次收费
--in_time：进车时间
--out_time：出车时间
--free_time：免费时间		默认 15分钟
--hour_1th：头一小时费率时间		1
--rate_1th：头一小时费率		默认 一类7元
--rate_30min：30分钟费率				3
--rate_limit：一天费率限额			60
--rate_night：夜间费率				6

function cal_rate(class,in_time,out_time,free_time,hour_1th,rate_1th,rate_30min,rate_limit,rate_night)
	--local today = os.date("*t")
	local rate=0
	local y1,M1,d1,h1,m1,s1 = string.match(in_time,"(%d+)-(%d+)-(%d+) (%d+):(%d+):(%d+)")
	local y2,M2,d2,h2,m2,s2 = string.match(out_time,"(%d+)-(%d+)-(%d+) (%d+):(%d+):(%d+)")

	print(string.format("1, %d %d %.2f %.2f %.2f %.2f",free_time,hour_1th,rate_1th,rate_30min,rate_limit,rate_night))	
--	print(class)
	from = os.time({year=y1,month=M1,day=d1,hour=h1,min=m1,sec=s1})
	--print(from)
	to = os.time({year=y2,month=M2,day=d2,hour=h2,min=m2,sec=s2})
	--print(to)
	sub = to - from
	--print(sub)

	if sub <0 then
		print("进车时间大于出车时间！")
		return
	end

	period_1min = 1 * 60
	period_1hour = 60 * 60
	period_1day = 24 * 60 * 60	
	
	parking_days = math.floor(sub /period_1day)
	--print(parking_days)
	parking_hours = math.floor((sub %period_1day)/period_1hour)
	--print(parking_hours)
	parking_mins = math.floor(((sub %period_1day)%period_1hour)/period_1min)
	--print(parking_mins)

	if class==0 or class==1 or class==2 then
		--一天之内
		if parking_days==0 then
			--白天进车
			if tonumber(h1)>=8 and tonumber(h1)<20 then
				--白天出车
				if tonumber(h2)>=8 and tonumber(h2)<20 then
					--第一天白天出车
					if (tonumber(h2) > tonumber(h1)) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) > tonumber(m1))) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) == tonumber(m1)) and (tonumber(s2) > tonumber(s1))) then
						--一小时之内
						if parking_hours<hour_1th then
							--15分钟之内免费
							if parking_mins<free_time then
								rate = 0		
							else
								rate = rate_1th
							end
						else
 							if parking_mins<30 then
								rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
							else
								rate = rate_1th + 2 *rate_30min *(parking_hours)
							end
						end
					--第二天白天出车
					else
						--第一天白天收费
						parking_hours = 20 -tonumber(h1) -1
		               	parking_mins = 60 - tonumber(m1)  
						if parking_hours<hour_1th then
							--15分钟之内免费
							if parking_mins<free_time then
								rate = 0		
							else
								rate = rate_1th
							end
						else                 
		    	            if parking_mins<30 then
		     	            	rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
		      	            else
		       	                rate = rate_1th + 2 *rate_30min *(parking_hours)
		  		      	    end
						end 
						--夜间时段收费
						rate = rate +rate_night   
						--第二天白天收费                                   
						parking_hours = tonumber(h2) -8	
						parking_mins = tonumber(m2) -0				
						if parking_hours<hour_1th then
                            if parking_mins<free_time then
                                 rate = rate +0
                            else
                                 rate = rate +rate_1th
                            end
                        else
                            if parking_mins<30 then
                               rate = rate +rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
                            else
                               rate = rate +rate_1th + 2 *rate_30min *(parking_hours)
                            end
                        end 
					end
				--夜间出车
				else
					parking_hours = 20 -tonumber(h1) -1
                    parking_mins = 60 - tonumber(m1)                 
                    if parking_mins<30 then
                    	rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
                    else
                        rate = rate_1th + 2 *rate_30min *(parking_hours)
                    end
					rate = rate +rate_night                                       			
				end
			--夜间进车
			else
				--第二天白天出车
				if tonumber(h2)>=8 and tonumber(h2)<20 then
					parking_hours = tonumber(h2) -8
					parking_mins = tonumber(m2) -0
					if parking_hours<hour_1th then
							--15分钟之内免费
							if parking_mins<free_time then
								rate = 0		
							else
								rate = rate_1th
							end
					else                     
		    	            if parking_mins<30 then
		     	            	rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
		      	            else
		       	                rate = rate_1th + 2 *rate_30min *(parking_hours)
		  		      	    end
					end
					rate = rate +rate_night
				--夜间出车判断
				else
					--第一天夜间出车
					if (tonumber(h2) > tonumber(h1)) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) > tonumber(m1))) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) == tonumber(m1)) and (tonumber(s2) > tonumber(s1))) then
						rate = rate_night
					--第二天夜间出车
					else
						parking_hours = 20-8
						parking_mins = 0					                   
				   	    rate = rate_1th + 2 *rate_30min *(parking_hours)				
						rate = rate +2*rate_night
					end                                   			
				end
			end
			if rate >rate_limit then
				rate = rate_limit
			end
		--一天以上	
		else
			local rate2 = rate_limit  -- *parking_days

			--白天进车
			--白天进车
			if tonumber(h1)>=8 and tonumber(h1)<20 then
				--白天出车
				if tonumber(h2)>=8 and tonumber(h2)<20 then
					--第一天白天出车
					if (tonumber(h2) > tonumber(h1)) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) > tonumber(m1))) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) == tonumber(m1)) and (tonumber(s2) > tonumber(s1))) then
						--一小时之内
						if parking_hours<hour_1th then
							--15分钟之内免费
							if parking_mins<free_time then
								rate = 0		
							else
								rate = rate_1th
							end
						else
 							if parking_mins<30 then
								rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
							else
								rate = rate_1th + 2 *rate_30min *(parking_hours)
							end
						end
					--第二天白天出车
					else
						--第一天白天收费
						parking_hours = 20 -tonumber(h1) -1
		               	parking_mins = 60 - tonumber(m1)  
						if parking_hours<hour_1th then
							--15分钟之内免费
							if parking_mins<free_time then
								rate = 0		
							else
								rate = rate_1th
							end
						else                 
		    	            if parking_mins<30 then
		     	            	rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
		      	            else
		       	                rate = rate_1th + 2 *rate_30min *(parking_hours)
		  		      	    end
						end 
						--夜间时段收费
						rate = rate +rate_night   
						--第二天白天收费                                   
						parking_hours = tonumber(h2) -8	
						parking_mins = tonumber(m2) -0				
						if parking_hours<hour_1th then
                            if parking_mins<free_time then
                                 rate = rate +0
                            else
                                 rate = rate +rate_1th
                            end
                        else
                            if parking_mins<30 then
                               rate = rate +rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
                            else
                               rate = rate +rate_1th + 2 *rate_30min *(parking_hours)
                            end
                        end 
					end
				--夜间出车
				else
					parking_hours = 20 -tonumber(h1) -1
                    parking_mins = 60 - tonumber(m1)                 
                    if parking_mins<30 then
                    	rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
                    else
                        rate = rate_1th + 2 *rate_30min *(parking_hours)
                    end
					rate = rate +rate_night                                       			
				end
			--夜间进车
			else
				--第二天白天出车
				if tonumber(h2)>=8 and tonumber(h2)<20 then
					parking_hours = tonumber(h2) -8
					parking_mins = tonumber(m2) -0
					if parking_hours<hour_1th then
							--15分钟之内免费
							if parking_mins<free_time then
								rate = 0		
							else
								rate = rate_1th
							end
					else                     
		    	            if parking_mins<30 then
		     	            	rate = rate_1th + 2 *rate_30min *(parking_hours-1) +rate_30min
		      	            else
		       	                rate = rate_1th + 2 *rate_30min *(parking_hours)
		  		      	    end
					end
					rate = rate +rate_night
				--夜间出车判断
				else
					--第一天夜间出车
					if (tonumber(h2) > tonumber(h1)) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) > tonumber(m1))) or ((tonumber(h2) == tonumber(h1)) and (tonumber(m2) == tonumber(m1)) and (tonumber(s2) > tonumber(s1))) then
						rate = rate_night
					--第二天夜间出车
					else
						parking_hours = 20-8
						parking_mins = 0					                   
				   	    rate = rate_1th + 2 *rate_30min *(parking_hours)				
						rate = rate +2*rate_night
					end                                   			
				end
			end
			if rate >rate_limit then
				rate = rate_limit
			end
			rate = rate +rate2
		end 
	elseif class==3 then
		--一天之内
		if parking_days==0 then
			if parking_hours<hour_1th then
				--1分钟之内免费
				if parking_mins<free_time then
					rate = 0		
				else
					rate = rate_1th
				end
			else						
				rate = rate_1th + 1 *(parking_hours-2)						
			end
			if rate >rate_limit then
				rate = rate_limit
			end
		end 
	--按次收费			
	elseif class==4 then
		rate =6	
	else
		rate=0
	end

	if class==0 then
		print(string.format("1类街道, 进车时间：%s 出车时间：%s 费率：%.2f元",in_time,out_time,rate))
	elseif class==1 then
		print(string.format("2类街道, 进车时间：%s 出车时间：%s 费率：%.2f元",in_time,out_time,rate))
	elseif class==2 then
		print(string.format("3类街道, 进车时间：%s 出车时间：%s 费率：%.2f元",in_time,out_time,rate))
	elseif class==3 then
		print(string.format("医大二院, 进车时间：%s 出车时间：%s 费率：%.2f元",in_time,out_time,rate))
	elseif class==4 then
		print(string.format("按次收费, 进车时间：%s 出车时间：%s 费率：%.2f元",in_time,out_time,rate))
	end

   	return rate
end
